%define expat_version           1.95.5
%define glib2_version           2.6.0
%define dbus_version            0.60
%define pygtk2			2.0.0
%define gnome_python2		2.0.0
%define libselinux_version      1.17.14-1
%define udev_version            057-3
%define util_linux_version      2.12a-16
%define doxygen_version         1.3.9.1-1
%define initscripts_version     8.04-1
%define kernel_version          2.6.11
%define gettext_version	        0.14.1-14
%define libusb_version          0.1.10a-1
%define dmidecode_version       2.7
%define cryptsetup_luks_version 1.0.1-2

%define hal_user_uid           68

Summary: Hardware Abstraction Layer
Name: hal
Version: 0.5.7
Release: 3.fc5.3
URL: http://www.freedesktop.org/Software/hal
Source0: %{name}-%{version}.tar.gz
Source1: 99-redhat-storage-policy-fixed-drives.fdi
Patch0: hal-0.5.7-fix-fedora-power-save.patch
Patch1: hal-0.5.7-lid-open-fix.patch
Patch2: hal-0.5.7-fix-for-nfs-and-autofs.patch
License: AFL/GPL
Group: System Environment/Libraries
BuildRoot: %{_tmppath}/%{name}-root
PreReq: chkconfig
BuildRequires: expat-devel >= %{expat_version}
BuildRequires: glib2-devel >= %{glib2_version}
BuildRequires: dbus-devel  >= %{dbus_version}
BuildRequires: python-devel
BuildRequires: hwdata
BuildRequires: libselinux-devel >= %{libselinux_version}
BuildRequires: doxygen >= %{doxygen_version}
BuildRequires: gettext >= %{gettext_version}
%ifnarch s390 s390x
BuildRequires: libusb-devel >= %{libusb_version}
%endif
Requires: dbus >= %{dbus_version}
Requires: dbus-glib >= %{dbus_version}
Requires: glib2 >= %{glib2_version}
Requires: udev >= %{udev_version} 
Requires: util-linux >= %{util_linux_version} 
Requires: libselinux >= %{libselinux_version}
Requires: initscripts >= %{initscripts_version}
Requires: cryptsetup-luks >= %{cryptsetup_luks_version}
Conflicts: kernel < %{kernel_version}
%ifnarch s390 s390x
Requires: libusb >= %{libusb_version}
%endif
%ifarch %{ix86} x86_64
Requires: dmidecode >= %{dmidecode_version}
%endif

%description

HAL is daemon for collection and maintaining information from several
sources about the hardware on the system. It provides a live device
list through D-BUS.

%package gnome
Summary: GNOME based device manager for HAL
Group: Development/Libraries
Requires: %name = %{version}-%{release}
Requires: dbus-python >= %{dbus_version}
Requires: pygtk2 >= %{pygtk2} 
Requires: gnome-python2 >= %{gnome_python2} 

%description gnome
GNOME program for displaying the devices detected by HAL


%package devel
Summary: Libraries and headers for HAL
Group: Development/Libraries
Requires: %name = %{version}-%{release}
Requires: dbus-devel >= %{dbus_version}

%description devel

Headers, static libraries and API docs for HAL.

%prep
%setup -q
%patch0 -p0 -b .fix-fedora-powersave
%patch1 -p1 -b .lid-open-fix
%patch2 -p1 -b .fix-for-nfs-and-autofs

%build

%configure --disable-docbook-docs --with-os-type=redhat

%install
make install DESTDIR=$RPM_BUILD_ROOT

cp -f %{SOURCE1} $RPM_BUILD_ROOT%{_datadir}/hal/fdi/policy/10osvendor/

rm -f $RPM_BUILD_ROOT%{_libdir}/*.la
rm -f $RPM_BUILD_ROOT%{_libdir}/*.a

%clean
rm -rf %{buildroot}

%pre
# Add the "haldaemon" user
/usr/sbin/useradd -c 'HAL daemon' -u %{hal_user_uid} \
	-s /sbin/nologin -r -d '/' haldaemon 2> /dev/null || :

%post
/sbin/ldconfig
/sbin/chkconfig --add haldaemon

%preun
if [ $1 = 0 ]; then
    service haldaemon stop > /dev/null 2>&1
    /sbin/chkconfig --del haldaemon
fi

%postun
/sbin/ldconfig
#if [ "$1" -ge "1" ]; then
#  service haldaemon condrestart > /dev/null 2>&1
#fi

%triggerpostun -- hal < 0.5.7-3
#remove lingering fstab-sync entries from /etc/fstab
/bin/cp -f /etc/fstab /etc/fstab.hal-save
(IFS="
"; while read line; do echo $line | awk '{print $4}' | grep -q managed || echo $line | grep -q "^#.*fstab-sync" || echo $line; done < /etc/fstab > fstab.replace)

if [ -s fstab.replace ]; then
  /bin/cp -f fstab.replace /etc/fstab
fi

%files
%defattr(-,root,root)
#%doc COPYING ChangeLog NEWS

%dir %{_sysconfdir}/dbus-1/system.d
%{_sysconfdir}/dbus-1/system.d/*

%config %{_sysconfdir}/rc.d/init.d/haldaemon

%dir %{_sysconfdir}/hal
%{_sysconfdir}/hal/*

%{_sbindir}/hald

%{_bindir}/lshal
%{_bindir}/hal-get-property
%{_bindir}/hal-set-property
%{_bindir}/hal-device
%{_bindir}/hal-find-by-capability
%{_bindir}/hal-find-by-property

%{_libexecdir}/*

%{_libdir}/*hal*.so.*

%dir %{_datadir}/hal
%dir %{_datadir}/hal/fdi
%dir %{_datadir}/hal/scripts
%dir %{_datadir}/doc/hal-%{version}
%dir %{_datadir}/doc/hal-%{version}/conf

%{_datadir}/hal/scripts/*
%{_datadir}/hal/fdi/*
%{_datadir}/locale/*
%{_datadir}/doc/hal-%{version}/conf/*

%{_sysconfdir}/udev/rules.d/90-hal.rules

%files devel
%defattr(-,root,root)

%dir %{_datadir}/doc/hal-%{version}/api

%{_libdir}/lib*.so
%{_libdir}/pkgconfig/*
%{_includedir}/*
%{_datadir}/doc/hal-%{version}/api/*
# TODO: include hal-spec


%files gnome
%defattr(-,root,root)

%dir %{_datadir}/hal/device-manager
%{_datadir}/hal/device-manager/*
%{_bindir}/hal-device-manager

%changelog
* Wed May 24 2006 John (J5) Palmieri <johnp@redhat.com> - 0.5.7-3.fc5.3
- Update autofs fix

* Wed May 17 2006 John (J5) Palmieri <johnp@redhat.com> - 0.5.7-3.fc5.2
- Add patch that makes hald not stat nfs and autofs mounts

* Wed Apr 26 2006 John (J5) Palmieri <johnp@redhat.com> - 0.5.7-3.fc5.1
- Add fix so gnome-power-manager handles lid opens correctly now

* Fri Mar 03 2006 John (J5) Palmieri <johnp@redhat.com> - 0.5.7-3
- Fix fstab clearing script to not strip whitespace

* Thu Mar 02 2006 John (J5) Palmieri <johnp@redhat.com> - 0.5.7-2
- clear out fstab of all fstab-sync entries if previous hal < 0.5.7-2

* Fri Feb 24 2006 David Zeuthen <davidz@redhat.com> - 0.5.7-1
- New upstream version 0.5.7 with several bug fixes
- Don't restart hald on package upgrade
- Pull in dmidecode on x86-ish and x86_64 architectures
- Don't let HAL's Mount() method circumvent system policy (#182352)
- Patch to use new pm-utils's new pm-powersave util properly

* Thu Feb 16 2006 Matthias Clasen <mclasen@redhat.com> - 0.5.7-0.cvs20060213.2
- fix directory ownership
- don't ship static libraries

* Mon Feb 13 2006 Jesse Keating <jkeating@redhat.com> - 0.5.7-0.cvs20060213.1.1
- rebump for build order issues during double-long bump

* Mon Feb 13 2006 David Zeuthen <davidz@redhat.com> - 0.5.7-0.cvs20060213.1
- fix build

* Mon Feb 13 2006 David Zeuthen <davidz@redhat.com> - 0.5.7-0.cvs20060213
- Upstream CVS snapshot. Drop a patch that is upstream. Switch to using
  udev rules instead of hotplug helpers for udev->hald channel.

* Tue Feb 07 2006 Jesse Keating <jkeating@redhat.com> - 0.5.6-3.1
- rebuilt for new gcc4.1 snapshot and glibc changes

* Wed Jan 18 2006 John (J5) Palmieri <johnp@redhat.com> - 0.5.6-3
- Patch storage-method policy so that the eject method is available
  to audio cd's

* Wed Jan 18 2006 John (J5) Palmieri <johnp@redhat.com> - 0.5.6-2
- Add policy file to ignore fixed disks.  This is a temporary solution
  until upstream comes up with a more flexable option

* Tue Jan 17 2006 John (J5) Palmieri <johnp@redhat.com> - 0.5.6
- New upstream release
- Remove match on capabilities patch (upstream already)

* Wed Jan 11 2006 Christopher Aillon <caillon@redhat.com> - 0.5.5.1.cvs20060111-1
- Update to an even newer CVS snapshot, to fix privelege escalation issue
- Remove mount options patch (upstreamed already)

* Mon Jan 09 2006 John (J5) Palmieri <johnp@redhat.com> - 0.5.5.1.cvs20060109-2
- Add patch to escape mount options

* Mon Jan 09 2006 John (J5) Palmieri <johnp@redhat.com> - 0.5.5.1.cvs20060109-1
- Update to a new CVS snapshot

* Thu Jan 05 2006 John (J5) Palmieri <johnp@redhat.com> - 0.5.5.1.cvs20060105-2
- readd the hotplug script

* Thu Jan 05 2006 John (J5) Palmieri <johnp@redhat.com> - 0.5.5.1.cvs20060105-1
- Build CVS version of HAL which gives us the new mount support
- disable fstab-sync
- scripts have been moved from /usr/sbin to /usr/share/hal/scripts

* Fri Dec 09 2005 Jesse Keating <jkeating@redhat.com> - 0.5.5.1-2.1
- rebuilt

* Wed Dec 01 2005 John (J5) Palmieri <johnp@redhat.com> - 0.5.5.1-2
- Rebuild for dbus 0.60

* Wed Nov 16 2005 John (J5) Palmieri <johnp@redhat.com> - 0.5.5.1-1
- Update to latest upstream version

* Fri Nov 11 2005 John (J5) Palmieri <johnp@redhat.com> - 0.5.4.cvs2005111-1
- Update to CVS HEAD

* Tue Nov 08 2005 John (J5) Palmieri <johnp@redhat.com> - 0.5.4-4
- Add patch to fix storage policy fdi to match on the storage
  capability and not category.
  
* Mon Oct  3 2005 Matthias Clasen <mclasen@redhat.com>
- Fix a typo in description

* Tue Aug 30 2005 David Zeuthen <davidz@redhat.com> - 0.5.4-3
- Rebuild

* Tue Aug 30 2005 David Zeuthen <davidz@redhat.com> - 0.5.4-2
- Pull in cryptsetup-luks and fix some unpackaged files

* Tue Aug 30 2005 David Zeuthen <davidz@redhat.com> - 0.5.4-1
- Update to upstream release 0.5.4 and drop patches already upstream

* Thu Aug 11 2005 David Zeuthen <davidz@redhat.com> - 0.5.3-4
- Add patch to make libhal-storage report the right fs usage (#165707)

* Tue Aug  9 2005 Jeremy Katz <katzj@redhat.com> - 0.5.3-3
- make kernel version requirement a conflicts instead

* Tue Jul 12 2005 David Zeuthen <davidz@redhat.com> 0.5.3-2
- Fix a minor packaging bug

* Tue Jul 12 2005 David Zeuthen <davidz@redhat.com> 0.5.3-1
- Update to upstream release 0.5.3
- Drop patches as they are upstream

* Mon May 23 2005 David Zeuthen <davidz@redhat.com> 0.5.2-2
- Fix doublefree when locking (#158474)
- Never use the 'sync' mount option (#157674)
- Update the fstab-sync man page (#158483)

* Thu May 12 2005 David Zeuthen <davidz@redhat.com> 0.5.2-1
- Update to upstream release 0.5.2

* Wed Apr 27 2005 David Zeuthen <davidz@redhat.com> 0.5.1-1
- Update to upstream release 0.5.1

* Tue Apr 19 2005 Florian La Roche <laroche@redhat.com>
- exclude usb reqs for mainframe (#154616)

* Mon Apr  4 2005 David Zeuthen <davidz@redhat.com> 0.5.0.cvs20050404b-2
- Rebuild

* Mon Apr  4 2005 David Zeuthen <davidz@redhat.com> 0.5.0.cvs20050404b-1
- Use new upstream tarball rather than patching configure

* Mon Apr  4 2005 David Zeuthen <davidz@redhat.com> 0.5.0.cvs20050404-3
- Add libusb checks to configure.in

* Mon Apr  4 2005 David Zeuthen <davidz@redhat.com> 0.5.0.cvs20050404-2
- Add BuildRequires and Requires for libusb

* Mon Apr  4 2005 David Zeuthen <davidz@redhat.com> 0.5.0.cvs20050404-1
- New snapshot from upstream CVS

* Tue Mar 22 2005 David Zeuthen <davidz@redhat.com> 0.5.0.cvs20050322b-1
- Another new snapshot from upstream CVS

* Tue Mar 22 2005 David Zeuthen <davidz@redhat.com> 0.5.0.cvs20050322-1
- New snapshot from upstream CVS

* Fri Mar 18 2005 David Zeuthen <davidz@redhat.com> 0.5.0.cvs20050318-1
- Snapshot from upstream CVS; should fix selinux labeling problems
  for /etc/fstab entries

* Thu Mar 10 2005 David Zeuthen <davidz@redhat.com> 0.5.0.cvs20050310-1
- Snapshot from CVS; should fix ACPI issues reported on f-d-l

* Tue Mar  8 2005 David Zeuthen <davidz@redhat.com> 0.5.0-3
- Rebuild

* Mon Mar  7 2005 David Zeuthen <davidz@redhat.com> 0.5.0-2
- Update to upstream release 0.5.0

* Thu Jan 27 2005 David Zeuthen <davidz@redhat.com> 0.4.7-2
- Add patch that should close #146316

* Mon Jan 24 2005 David Zeuthen <davidz@redhat.com> 0.4.7-1
- New upstream release.
- Should close #145921, #145750, #145293, #145256

* Mon Jan 24 2005 John (J5) Palmieri <johnp@redhat.com> 0.4.6-3
- Update required dbus version to 0.23 

* Thu Jan 20 2005 David Zeuthen <davidz@redhat.com> 0.4.6-2
- Fix parameters to configure

* Thu Jan 20 2005 David Zeuthen <davidz@redhat.com> 0.4.6-1
- New upstream release
- Should close #145099, #144600, #140150, #145223, #137672

* Wed Jan 12 2005 David Zeuthen <davidz@redhat.com> 0.4.5-1
- New upstream release.
- Should close #142834, #141771, #142183

* Fri Dec 12 2004 David Zeuthen <davidz@redhat.com> 0.4.2.cvs20041210-1
- Snapshot from stable branch of upstream CVS

* Tue Oct 26 2004 David Zeuthen <davidz@redhat.com> 0.4.0-8
- Forgot to add some diffs in hal-0.4.0-pcmcia-net-support.patch

* Tue Oct 26 2004 David Zeuthen <davidz@redhat.com> 0.4.0-7
- Change default policy such that non-hotpluggable fixed disks are not
  added to the /etc/fstab file because a) ATARAID detection in hal is
  incomplete (e.g. RAID members from ATARAID controllers might be added
  to /etc/fstab); and b) default install wont corrupt multiboot 
  systems on fixed drives (#137072)

* Tue Oct 26 2004 David Zeuthen <davidz@redhat.com> 0.4.0-6
- Fix hotplug timeout handling (#136626)
- Detect ATARAID devices and do not add /etc/fstab entry for them
- Probe for ext3 before ntfs (#136966)
- Use fstype 'auto' for optical drives instead of 'iso9660,udf'
- Properly detect wireless ethernet devices  (#136591)
- Support 16-bit PCMCIA networking devices (by Dan Williams) (#136658)

* Tue Oct 19 2004 David Zeuthen <davidz@redhat.com> 0.4.0-5
- Make hal work with PCMCIA IDE hotpluggable devices (#133943)
- Fixup URL listed from rpm -qi (#136396)
- Add Portuguese translations for hal
- Fix addition of Russian and Hungarian translations

* Mon Oct 18 2004 David Zeuthen <davidz@redhat.com> 0.4.0-4
- Make hald cope with missing hotplug events from buggy drivers (#135202)
- Fix the order of mount options in fstab-sync (#136191)
- Allow x86 legacy floppy drives in default policy (#133777)
- Fix fstab-sync crashing without any options and not run from hald (#136214)
- man page for fstab-sync references non-existing files (#136026)
- Add Russian translations for hal (#135853)
- Add Hungarian translations for hal

* Fri Oct 15 2004 David Zeuthen <davidz@redhat.com> 0.4.0-3
- Fix bad use of O_NONBLOCK as the 2.6.8-1.624 kernel exposes this (#135886)
- Never use the UUID as mount point candidate in the default policy 
  as it is unfriendly (#135907)
- Fix a trivial bug in fstab-sync so the syslog messages actually expose
  the device name instead of just the word foo

* Thu Oct 14 2004 David Zeuthen <davidz@redhat.com> 0.4.0-2
- Fix issue with fstab-sync not cleaning /etc/fstab on startup

* Thu Oct 14 2004 David Zeuthen <davidz@redhat.com> 0.4.0-1
- Update to upstream stable version 0.4.0
- Remove patch for libhal shutdown since that is now upstream
- fstab-sync: man page, adds comment in /etc/fstab pointing to man page

* Fri Oct 01 2004 David Zeuthen <davidz@redhat.com> 0.2.98.cvs20040929-3
- Fix a bug so libhal actually invoke callback functions when needed

* Fri Oct 01 2004 John (J5) Palmieri <johnp@redhat.com> 0.2.98.cvs20040929-2
- Use "user" mount flag for now until "pamconsole" flag gets into mount

* Wed Sep 29 2004 David Zeuthen <davidz@redhat.com> 0.2.98.cvs20040929-1
- Update to upstream CVS version
- Enable libselinux again

* Mon Sep 27 2004 David Zeuthen <davidz@redhat.com> 0.2.98.cvs20040927-1
- Update to upstream CVS version

* Fri Sep 24 2004 David Zeuthen <davidz@redhat.com> 0.2.98.cvs20040923-1
- Update to upstream CVS release
- Include libhal-storage library
- Should close bug #132876

* Mon Sep 20 2004 David Zeuthen <davidz@redhat.com> 0.2.98-4
- Rebuilt

* Mon Sep 20 2004 David Zeuthen <davidz@redhat.com> 0.2.98-3
- Rebuilt

* Mon Sep 20 2004 David Zeuthen <davidz@redhat.com> 0.2.98-2
- Temporarily disable explicit requirement for libselinux

* Mon Sep 20 2004 David Zeuthen <davidz@redhat.com> 0.2.98-1
- Update to upstream release 0.2.98. 
- Use --with-pid-file so we don't depend on /etc/redhat-release

* Wed Sep 01 2004 David Zeuthen <davidz@redhat.com> 0.2.97.cvs20040901-1
- Update to upstream CVS HEAD

* Tue Aug 31 2004 David Zeuthen <davidz@redhat.com> 0.2.97.cvs20040831-3
- Add UID for haldaemon user

* Tue Aug 31 2004 David Zeuthen <davidz@redhat.com> 0.2.97.cvs20040831-2
- Rebuilt with a newer snapshot.

* Fri Aug 27 2004 David Zeuthen <davidz@redhat.com> 0.2.97.cvs20040827-3
- Rebuilt

* Fri Aug 27 2004 David Zeuthen <davidz@redhat.com> 0.2.97.cvs20040827-2
- Rebuilt
- Closes RH Bug #130971

* Fri Aug 27 2004 David Zeuthen <davidz@redhat.com> 0.2.97.cvs20040827-1
- Update to upstream CVS HEAD. 
- Should close RH Bug #130588

* Wed Aug 25 2004 David Zeuthen <davidz@redhat.com> 0.2.97.cvs20040823-3
- Rebuilt

* Wed Aug 25 2004 David Zeuthen <davidz@redhat.com> 0.2.97.cvs20040823-2
- Apply a patch so hald doesn't hang on startup.

* Mon Aug 23 2004 David Zeuthen <davidz@redhat.com> 0.2.97.cvs20040823-1
- Update to upstream CVS HEAD
- Remove symlinking of fstab-sync from specfile since this is now being
  done in the package

* Mon Aug 23 2004 Florian La Roche <Florian.LaRoche@redhat.de>
- change the %%define names to not use "-"

* Thu Aug 19 2004 David Zeuthen <davidz@redhat.com> 0.2.97.cvs20040819-1
- Update to upstream CVS HEAD
- Remove suid patch as it is fixed upstream
- Fix some dependency issues (RH Bug #130202)

* Wed Aug 18 2004 John (J5) Palmieri <johnp@redhat.com> 0.2.97-2
- Add stopgap patch to remove suid from mount flags (RH Bug #130290)

* Mon Aug 16 2004 David Zeuthen <davidz@redhat.com> 0.2.97-1
- update to upstream release 0.2.97
- use kudzu option in fstab-sync since updfstab is now disabled

* Thu Aug 12 2004 John (J5) Palmieri <johnp@redhat.com> 0.2.96-2
- fixed Requires lines to use %{} instead of ${}
- made dbus related requires lines use the = condition instead of =<
  because the dbus API is still in flux

* Thu Aug 12 2004 David Zeuthen <davidz@redhat.com> 0.2.96
- Update to upstream release 0.2.96
- Symlink fstab-sync into /etc/hal/device.d on install

* Fri Aug 06 2004 John (J5) Palmieri <johnp@redhat.com> 0.2.95.cvs20040802-2
- Base hal package no longer requires python

* Mon Aug 02 2004 John (J5) Palmieri <johnp@redhat.com> 0.2.95.cvs20040802-1
- Update to CVS head
- Remove Dan's patches as they were commited to CVS

* Fri Jul 30 2004 Dan Williams <dcbw@redhat.com> 0.2.93.cvs.20040712-2
- Fix netlink sockets pointer arithmetic bug

* Mon Jul 12 2004 John (J5) Palmieri <johnp@redhat.com> 0.2.93.cvs.20040712-1
- Update to new CVS version as of 7-12-2004

* Fri Jun 25 2004 John (J5) Palmieri <johnp@redhat.com> 0.2.92.cvs.20040611-2
- take out fstab-update.sh from install
- add to rawhide
 
* Fri Jun 11 2004 John (J5) Palmieri <johnp@redhat.com> 0.2.92.cvs.20040611-1 
- update to CVS head as of 6-11-2004 which contains dcbw's 
  network link status fix 

* Wed Jun 9 2004 Ray Strode <rstrode@redhat.com> 0.2.91.cvs20040527-2
- added dependency on udev

* Wed May 12 2004 John (J5) Palmieri <johnp@redhat.com> 0.2.91.cvs20040527-1
- update to CVS head as of 5-27-2004 which contains fixes for PCMCIA
  and wireless network devices.

* Wed May 12 2004 John (J5) Palmieri <johnp@redhat.com> 0.2.90.cvs20040511-3
- added hal-0.2.90.cvs20040511.callbackscripts.patch which installs 
  the file system mounting script in /etc/hal/device.d

* Wed May 12 2004 John (J5) Palmieri <johnp@redhat.com> 0.2.90.cvs20040511-2
- added the %{_sysconfigdir}/hal directory tree to %files 

* Tue May 11 2004 John (J5) Palmieri <johnp@redhat.com> 0.2.90.cvs20040511-1
- update to CVS head as of 5-11-2004

* Wed May 5 2004 Christopher Blizzard <blizzard@redhat.com> 0.2.90-2
- Install hal.dev from /etc/dev.d/default/

* Mon Apr 19 2004 John (J5) Palmieri <johnp@redhat.com> 0.2.90-1
- upstream update

* Mon Apr 19 2004 John (J5) Palmieri <johnp@redhat.com> 0.2-1 
- initial checkin to package repository
- added dependency to the dbus-python package
- added %{_libexecdir}/hal.dev to teh %files section
